#!/usr/bin/perl -T

our $debug = 0; $|++; use Data::Dumper; # Yes, it's that alpha.
use strict; use warnings;

use File::stat;

BEGIN { push @INC, "./"; } 

use Net::Server::POP3;
use DateTime; use DateTime::Format::Mail;

my @inbox = ();
my $serv = Net::Server::POP3->new
  (
   serveropts => +{
                   log_level => 3,
                  },
   authenticate => sub {
     my ($user, $pass, $ip) = @_;

#zadna autentifikace, proste jakekoliv heslo

         push @inbox, newmessage($user, $ip);

   },

   list => sub {
     my ($username) = @_;
     return map { $$_[0] } @inbox;
   },

   retrieve => sub {
     warn "Attempting to retrieve @_\n" if $debug;
     my ($username, $msgid) = @_;
     warn "retrieve using inbox:\n".Dumper(\@inbox)."\n" if $debug;
     my @l = grep { $$_[0] eq $msgid } @inbox;
     warn "retrieve found matching messages: " . Dumper(\@l) . "\n" if $debug;
     my $msg = $l[0][1];
     warn "$msg\n" if $debug;
     return $msg;
   },

   size => sub {
     warn "Attempting to find size of @_\n" if $debug;
     my ($username, $msgid) = @_;
     my $msg = (grep {$$_[0] eq $msgid } @inbox)[0];
     warn "Found message: ".Dumper(\$msg)."\n" if $debug;
     my $len = length $$msg[1];
     warn "simpletest:  message $msgid has no size:\n" . Dumper(\$msg) . "\n" unless $len;
     warn "Found size:  $len\n" if $debug;
     return $len;
   },
  );

my $newmsgnum;


sub newmessage {
  ++$newmsgnum;
  my ($username, $ip) = @_;

    my $newmsgtext = "";

    my $handmail;my $in;

    my $nsgid;
    my $mailstatus=stat("./email.msg");

    if ($mailstatus)
    {
    open ($handmail, "./email.msg");
    while($in=<$handmail>)
    {
        $in=~s#\r+##g;
	if (!$nsgid)
	{
	    $in=~s#^To\:#ToFrom:#;
	    $in=~s#^From\:#To:#;
	    $in=~s#^ToFrom\:#From:#;
	}
        $newmsgtext.=$in;
        if ($newmsgtext=~/Message-ID\: (.*)/){$nsgid=$1;}
	    elsif($newmsgtext=~/Date\: (.*)/)
	    {
		$nsgid=$1;
		$nsgid=~s#[^\w]##g;
                $newmsgtext=~s#To\:#Message-ID: $nsgid\nTo:#;
	    }
    }
    close $handmail;
    }

    if ((!$mailstatus)||(time-($mailstatus->mtime)>240))
   {
    $nsgid="pro-mou-milovanou-merit";
    $newmsgtext = <<"MESSAGE";
Received: from localhost by fakemail
From: milan\@kvasnica.cz
To: $username
Message-ID: $nsgid
Subject: Vitejte...
Content-Type: text/plain; charset=us-ascii
Date: Sat, 04 Feb 2017 03:05:07 +0100

Sluzba slouzi k falsovani emailu.

0) zmenit datum v pocitaci
1) odeslat email
2) prijmout email (obratem)
3) profit

--Kvasnica

MESSAGE
   }

  return [$nsgid, $newmsgtext];
}


$serv->startserver(port      => '110');


